--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.393924923 +0100
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas3/mptsas3.c	2014-06-12 17:42:15.405774308 +0100
@@ -21,8 +21,10 @@
 
 /*
  * Copyright (c) 2009, 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright 2012 Nexenta Systems, Inc. All rights reserved.
+ * Copyright 2014 Nexenta Systems, Inc. All rights reserved.
  * Copyright (c) 2014, Joyent, Inc. All rights reserved.
+ * Copyright (c) 2014, Tegile Systems Inc. All rights reserved.
+ * Copyright 2014 OmniTI Computer Consulting, Inc. All rights reserved.
  */
 
 /*
@@ -53,7 +55,7 @@
  */
 
 /*
- * mptsas - This is a driver based on LSI Logic's MPT2.0 interface.
+ * mptsas3 - This is a driver based on LSI Logic's MPT2.0/2.5 interface.
  *
  */
 
@@ -78,14 +80,14 @@
 #include <sys/scsi/impl/scsi_sas.h>
 
 #pragma pack(1)
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_type.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_cnfg.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_init.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_ioc.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_sas.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_tool.h>
-#include <sys/scsi/adapters/mpt_sas/mpi/mpi2_raid.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_type.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_cnfg.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_init.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_ioc.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_sas.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_tool.h>
+#include <sys/scsi/adapters/mpt_sas3/mpi/mpi2_raid.h>
 #pragma pack()
 
 /*
@@ -93,10 +95,10 @@
  *
  */
 #include <sys/scsi/impl/scsi_reset_notify.h>
-#include <sys/scsi/adapters/mpt_sas/mptsas_var.h>
-#include <sys/scsi/adapters/mpt_sas/mptsas_ioctl.h>
-#include <sys/scsi/adapters/mpt_sas/mptsas_smhba.h>
-#include <sys/scsi/adapters/mpt_sas/mptsas_hash.h>
+#include <sys/scsi/adapters/mpt_sas3/mptsas3_var.h>
+#include <sys/scsi/adapters/mpt_sas3/mptsas3_ioctl.h>
+#include <sys/scsi/adapters/mpt_sas3/mptsas3_smhba.h>
+#include <sys/scsi/adapters/mpt_sas3/mptsas3_hash.h>
 #include <sys/raidioctl.h>
 
 #include <sys/fs/dv_node.h>	/* devfs_clean */
@@ -144,9 +146,11 @@
 static int mptsas_cache_create(mptsas_t *mpt);
 static void mptsas_cache_destroy(mptsas_t *mpt);
 static int mptsas_alloc_request_frames(mptsas_t *mpt);
+static int mptsas_alloc_sense_bufs(mptsas_t *mpt);
 static int mptsas_alloc_reply_frames(mptsas_t *mpt);
 static int mptsas_alloc_free_queue(mptsas_t *mpt);
 static int mptsas_alloc_post_queue(mptsas_t *mpt);
+static void mptsas_free_post_queue(mptsas_t *mpt);
 static void mptsas_alloc_reply_args(mptsas_t *mpt);
 static int mptsas_alloc_extra_sgl_frame(mptsas_t *mpt, mptsas_cmd_t *cmd);
 static void mptsas_free_extra_sgl_frame(mptsas_t *mpt, mptsas_cmd_t *cmd);
@@ -201,9 +205,14 @@
 static void mptsas_ncmds_checkdrain(void *arg);
 
 static int mptsas_prepare_pkt(mptsas_cmd_t *cmd);
-static int mptsas_accept_pkt(mptsas_t *mpt, mptsas_cmd_t *sp);
-static int mptsas_accept_txwq_and_pkt(mptsas_t *mpt, mptsas_cmd_t *sp);
-static void mptsas_accept_tx_waitq(mptsas_t *mpt);
+static void mptsas_retry_pkt(mptsas_t *mpt, mptsas_cmd_t *sp);
+static int mptsas_save_cmd_to_slot(mptsas_t *mpt, mptsas_cmd_t *cmd);
+static int mptsas_accept_pkt(mptsas_t *mpt, mptsas_cmd_t *sp,
+    int *tran_rval);
+static void mptsas_accept_tx_waitqs(mptsas_t *mpt);
+static void mptsas_unblock_tx_waitqs(mptsas_t *mpt);
+static void mptsas_drain_tx_waitq(mptsas_t *mpt, mptsas_tx_waitqueue_t *txwq);
+static int mptsas_check_targ_intxtion(mptsas_target_t *ptgt, int cmd_pkt_flags);
 
 static int mptsas_do_detach(dev_info_t *dev);
 static int mptsas_do_scsi_reset(mptsas_t *mpt, uint16_t devhdl);
@@ -227,10 +236,10 @@
     uchar_t reason, uint_t stat);
 
 static uint_t mptsas_intr(caddr_t arg1, caddr_t arg2);
-static void mptsas_process_intr(mptsas_t *mpt,
+static void mptsas_process_intr(mptsas_t *mpt, mptsas_reply_pqueue_t *rpqp,
     pMpi2ReplyDescriptorsUnion_t reply_desc_union);
 static void mptsas_handle_scsi_io_success(mptsas_t *mpt,
-    pMpi2ReplyDescriptorsUnion_t reply_desc);
+    mptsas_reply_pqueue_t *rpqp, pMpi2ReplyDescriptorsUnion_t reply_desc);
 static void mptsas_handle_address_reply(mptsas_t *mpt,
     pMpi2ReplyDescriptorsUnion_t reply_desc);
 static int mptsas_wait_intr(mptsas_t *mpt, int polltime);
@@ -239,12 +248,12 @@
 
 static void mptsas_watch(void *arg);
 static void mptsas_watchsubr(mptsas_t *mpt);
-static void mptsas_cmd_timeout(mptsas_t *mpt, uint16_t devhdl);
+static void mptsas_cmd_timeout(mptsas_t *mpt, mptsas_target_t *ptgt);
 
 static void mptsas_start_passthru(mptsas_t *mpt, mptsas_cmd_t *cmd);
 static int mptsas_do_passthru(mptsas_t *mpt, uint8_t *request, uint8_t *reply,
     uint8_t *data, uint32_t request_size, uint32_t reply_size,
-    uint32_t data_size, uint32_t direction, uint8_t *dataout,
+    uint32_t data_size, uint8_t direction, uint8_t *dataout,
     uint32_t dataout_size, short timeout, int mode);
 static int mptsas_free_devhdl(mptsas_t *mpt, uint16_t devhdl);
 
@@ -299,24 +308,32 @@
 static void mptsas_restart_hba(mptsas_t *mpt);
 static void mptsas_restart_waitq(mptsas_t *mpt);
 
-static void mptsas_deliver_doneq_thread(mptsas_t *mpt);
+static void mptsas_deliver_doneq_thread(mptsas_t *mpt,
+    mptsas_done_list_t *dlist);
 static void mptsas_doneq_add(mptsas_t *mpt, mptsas_cmd_t *cmd);
-static void mptsas_doneq_mv(mptsas_t *mpt, uint64_t t);
+static void mptsas_rpdoneq_add(mptsas_t *mpt, mptsas_reply_pqueue_t *rpqp,
+    mptsas_cmd_t *cmd);
+static void mptsas_doneq_mv(mptsas_done_list_t *from,
+    mptsas_doneq_thread_list_t *item);
 
 static mptsas_cmd_t *mptsas_doneq_thread_rm(mptsas_t *mpt, uint64_t t);
 static void mptsas_doneq_empty(mptsas_t *mpt);
-static void mptsas_doneq_thread(mptsas_doneq_thread_arg_t *arg);
+static void mptsas_rpdoneq_empty(mptsas_reply_pqueue_t *rpqp);
+static void mptsas_doneq_thread(mptsas_thread_arg_t *arg);
+static void mptsas_tx_waitq_thread(mptsas_thread_arg_t *arg);
 
 static mptsas_cmd_t *mptsas_waitq_rm(mptsas_t *mpt);
 static void mptsas_waitq_delete(mptsas_t *mpt, mptsas_cmd_t *cmd);
-static mptsas_cmd_t *mptsas_tx_waitq_rm(mptsas_t *mpt);
-static void mptsas_tx_waitq_delete(mptsas_t *mpt, mptsas_cmd_t *cmd);
-
 
 static void mptsas_start_watch_reset_delay();
 static void mptsas_setup_bus_reset_delay(mptsas_t *mpt);
 static void mptsas_watch_reset_delay(void *arg);
 static int mptsas_watch_reset_delay_subr(mptsas_t *mpt);
+static void mptsas_set_throttle(struct mptsas *mpt, mptsas_target_t *ptgt,
+    int what);
+static void mptsas_set_throttle_mtx(struct mptsas *mpt, mptsas_target_t *ptgt,
+    int what);
+static void mptsas_remove_cmd_nomtx(mptsas_t *mpt, mptsas_cmd_t *cmd);
 
 /*
  * helper functions
@@ -369,7 +386,9 @@
     dev_info_t **lundip);
 
 static int mptsas_config_target(dev_info_t *pdip, mptsas_target_t *ptgt);
-static int mptsas_offline_target(dev_info_t *pdip, char *name);
+static int mptsas_offline_targetdev(dev_info_t *pdip, char *name);
+static void mptsas_offline_target(mptsas_t *mpt, mptsas_target_t *ptgt,
+    uint8_t topo_flags, dev_info_t *parent);
 
 static int mptsas_config_raid(dev_info_t *pdip, uint16_t target,
     dev_info_t **dip);
@@ -425,8 +444,14 @@
  * By default MSI is enabled on all supported platforms.
  */
 boolean_t mptsas_enable_msi = B_TRUE;
+boolean_t mptsas_enable_msix = B_TRUE;
 boolean_t mptsas_physical_bind_failed_page_83 = B_FALSE;
 
+/*
+ * Global switch for use of MPI2.5 FAST PATH.
+ */
+boolean_t mptsas3_use_fastpath = B_TRUE;
+
 static int mptsas_register_intrs(mptsas_t *);
 static void mptsas_unregister_intrs(mptsas_t *);
 static int mptsas_add_intrs(mptsas_t *, int);
@@ -440,6 +465,14 @@
 static int mptsas_fm_error_cb(dev_info_t *, ddi_fm_error_t *, const void *);
 
 extern pri_t minclsyspri, maxclsyspri;
+/*
+ * NCPUS is used to determine some optimal configurations for number
+ * of threads created to perform specific jobs. If we are invoked because
+ * a disk is part of the root file system ncpus may still be 1 so check
+ * boot_ncpus as well.
+ */
+extern int ncpus, boot_ncpus;
+#define	NCPUS	max(ncpus, boot_ncpus)
 
 /*
  * This device is created by the SCSI pseudo nexus driver (SCSI vHCI).  It is
@@ -455,6 +488,13 @@
 int mptsas_inq83_retry_timeout = 30;
 
 /*
+ * Tunable for default SCSI pkt timeout. Defaults to 5 seconds, which should
+ * be plenty for INQUIRY and REPORT_LUNS, which are the only commands currently
+ * issued by mptsas directly.
+ */
+int mptsas_scsi_pkt_time = 5;
+
+/*
  * This is used to allocate memory for message frame storage, not for
  * data I/O DMA. All message frames must be stored in the first 4G of
  * physical memory.
@@ -490,7 +530,7 @@
 	0xffffffffull,	/* max segment size (DMA boundary)	*/
 	MPTSAS_MAX_DMA_SEGS, /* scatter/gather list length	*/
 	512,		/* granularity - device transfer size	*/
-	DDI_DMA_RELAXED_ORDERING	/* flags, enable relaxed ordering */
+	0		/* flags, set to 0 */
 };
 
 ddi_device_acc_attr_t mptsas_dev_attr = {
@@ -545,7 +585,7 @@
 };
 
 
-#define	MPTSAS_MOD_STRING "MPTSAS HBA Driver 00.00.00.24"
+#define	MPTSAS_MOD_STRING "MPTSAS3 HBA Driver 00.00.01"
 
 static struct modldrv modldrv = {
 	&mod_driverops,	/* Type of module. This one is a driver */
@@ -568,12 +608,19 @@
  * Local static data
  */
 #if defined(MPTSAS_DEBUG)
-uint32_t mptsas_debug_flags = 0;
+uint32_t mptsas_debug_flags = 0x0;
+/*
+ * Flags to ignore these messages in local debug ring buffer.
+ * Default is to ignore the watchsubr() output which normally happens
+ * every second.
+ */
+uint32_t mptsas_dbglog_imask = 0x40000000;
+uint32_t mptsas_test_timeout = 0;
 #endif	/* defined(MPTSAS_DEBUG) */
 uint32_t mptsas_debug_resets = 0;
 
 static kmutex_t		mptsas_global_mutex;
-static void		*mptsas_state;		/* soft	state ptr */
+static void		*mptsas3_state;		/* soft	state ptr */
 static krwlock_t	mptsas_global_rwlock;
 
 static kmutex_t		mptsas_log_mutex;
@@ -586,6 +633,35 @@
 static timeout_id_t mptsas_reset_watch;
 static timeout_id_t mptsas_timeout_id;
 static int mptsas_timeouts_enabled = 0;
+
+/*
+ * Maximum number of MSI-X interrupts any instance of mptsas3 can use.
+ * Note that if you want to increase this you may have to also bump the
+ * value of ddi_msix_alloc_limit which defaults to 8.
+ * Set to zero to fall back to other interrupt types.
+ */
+int mptsas3_max_msix_intrs = 8;
+
+/*
+ * Default length for extended auto request sense buffers.
+ * All sense buffers need to be under the same alloc because there
+ * is only one common top 32bits (of 64bits) address register.
+ * Most requests only require 32 bytes, but some request >256.
+ * We use rmalloc()/rmfree() on this additional memory to manage the
+ * "extended" requests.
+ */
+int mptsas_extreq_sense_bufsize = 256*64;
+
+/*
+ * Believe that all software resrictions of having to run with DMA
+ * attributes to limit allocation to the first 4G are removed.
+ * However, this flag remains to enable quick switchback should suspicious
+ * problems emerge.
+ * Note that scsi_alloc_consistent_buf() does still adhering to allocating
+ * 32 bit addressable memory, but we can cope if that is changed now.
+ */
+int mptsas_use_64bit_msgaddr = 1;
+
 /*
  * warlock directives
  */
@@ -619,14 +695,14 @@
 
 	NDBG0(("_init"));
 
-	status = ddi_soft_state_init(&mptsas_state, MPTSAS_SIZE,
+	status = ddi_soft_state_init(&mptsas3_state, MPTSAS_SIZE,
 	    MPTSAS_INITIAL_SOFT_SPACE);
 	if (status != 0) {
 		return (status);
 	}
 
 	if ((status = scsi_hba_init(&modlinkage)) != 0) {
-		ddi_soft_state_fini(&mptsas_state);
+		ddi_soft_state_fini(&mptsas3_state);
 		return (status);
 	}
 
@@ -638,7 +714,7 @@
 		mutex_destroy(&mptsas_log_mutex);
 		rw_destroy(&mptsas_global_rwlock);
 		mutex_destroy(&mptsas_global_mutex);
-		ddi_soft_state_fini(&mptsas_state);
+		ddi_soft_state_fini(&mptsas3_state);
 		scsi_hba_fini(&modlinkage);
 	}
 
@@ -659,7 +735,7 @@
 	NDBG0(("_fini"));
 
 	if ((status = mod_remove(&modlinkage)) == 0) {
-		ddi_soft_state_fini(&mptsas_state);
+		ddi_soft_state_fini(&mptsas3_state);
 		scsi_hba_fini(&modlinkage);
 		mutex_destroy(&mptsas_global_mutex);
 		rw_destroy(&mptsas_global_rwlock);
@@ -765,6 +841,7 @@
 
 	for (tp = refhash_first(mpt->m_targets); tp != NULL;
 	    tp = refhash_next(mpt->m_targets, tp)) {
+		mutex_destroy(&tp->m_t_mutex);
 		refhash_remove(mpt->m_targets, tp);
 	}
 	for (sp = refhash_first(mpt->m_smp_targets); sp != NULL;
@@ -799,7 +876,7 @@
 	uint64_t		attached_sas_wwn;
 	uint16_t		dev_hdl;
 	uint16_t		pdev_hdl;
-	uint16_t		bay_num, enclosure;
+	uint16_t		bay_num, enclosure, io_flags;
 	char			attached_wwnstr[MPTSAS_WWN_STRLEN];
 
 	/* CONSTCOND */
@@ -961,7 +1038,7 @@
 	    MPI2_SAS_DEVICE_PGAD_FORM_MASK) | (uint32_t)attached_devhdl;
 	rval = mptsas_get_sas_device_page0(mpt, page_address, &dev_hdl,
 	    &attached_sas_wwn, &dev_info, &phy_port, &phy_id,
-	    &pdev_hdl, &bay_num, &enclosure);
+	    &pdev_hdl, &bay_num, &enclosure, &io_flags);
 	if (rval != DDI_SUCCESS) {
 		mptsas_log(mpt, CE_WARN,
 		    "Failed to get device page0 for handle:%d",
@@ -1018,8 +1095,7 @@
 {
 	mptsas_t		*mpt = NULL;
 	int			instance, i, j;
-	int			doneq_thread_num;
-	char			intr_added = 0;
+	int			q_thread_num;
 	char			map_setup = 0;
 	char			config_setup = 0;
 	char			hba_attach_setup = 0;
@@ -1028,6 +1104,8 @@
 	char			event_taskq_create = 0;
 	char			dr_taskq_create = 0;
 	char			doneq_thread_create = 0;
+	char			txwq_thread_create = 0;
+	char			added_watchdog = 0;
 	scsi_hba_tran_t		*hba_tran;
 	uint_t			mem_bar = MEM_SPACE;
 	int			rval = DDI_FAILURE;
@@ -1142,13 +1220,13 @@
 	/*
 	 * Allocate softc information.
 	 */
-	if (ddi_soft_state_zalloc(mptsas_state, instance) != DDI_SUCCESS) {
+	if (ddi_soft_state_zalloc(mptsas3_state, instance) != DDI_SUCCESS) {
 		mptsas_log(NULL, CE_WARN,
 		    "mptsas%d: cannot allocate soft state", instance);
 		goto fail;
 	}
 
-	mpt = ddi_get_soft_state(mptsas_state, instance);
+	mpt = ddi_get_soft_state(mptsas3_state, instance);
 
 	if (mpt == NULL) {
 		mptsas_log(NULL, CE_WARN,
@@ -1164,11 +1242,20 @@
 
 	/* Make a per-instance copy of the structures */
 	mpt->m_io_dma_attr = mptsas_dma_attrs64;
-	mpt->m_msg_dma_attr = mptsas_dma_attrs;
+	if (mptsas_use_64bit_msgaddr) {
+		mpt->m_msg_dma_attr = mptsas_dma_attrs64;
+	} else {
+		mpt->m_msg_dma_attr = mptsas_dma_attrs;
+	}
 	mpt->m_reg_acc_attr = mptsas_dev_attr;
 	mpt->m_dev_acc_attr = mptsas_dev_attr;
 
 	/*
+	 * Round down the arq sense buffer size to nearest 16 bytes.
+	 */
+	mpt->m_req_sense_size = EXTCMDS_STATUS_SIZE;
+
+	/*
 	 * Initialize FMA
 	 */
 	mpt->m_fm_capabilities = ddi_getprop(DDI_DEV_T_ANY, mpt->m_dip,
@@ -1222,18 +1309,63 @@
 	}
 	dr_taskq_create++;
 
+	cv_init(&mpt->m_qthread_cv, NULL, CV_DRIVER, NULL);
+	mutex_init(&mpt->m_qthread_mutex, NULL, MUTEX_DRIVER, NULL);
+
+	i = ddi_prop_get_int(DDI_DEV_T_ANY, dip,
+	    0, "mptsas_enable_txwq_prop", NCPUS > 1);
+	if (i) {
+		mpt->m_txwq_thread_n = NUM_TX_WAITQ;
+		mpt->m_txwq_enabled = FALSE;
+		if (ddi_prop_get_int(DDI_DEV_T_ANY, dip,
+		    0, "mptsas_allow_txwq_jumping", 0)) {
+			mpt->m_txwq_allow_q_jumping = TRUE;
+		}
+		i = ddi_prop_get_int(DDI_DEV_T_ANY, dip,
+		    0, "mptsas_txwq_threashold_prop", 80000);
+		mpt->m_txwq_thread_threshold = (uint16_t)i;
+	} else {
+		mpt->m_txwq_thread_n = 0;
+		mpt->m_txwq_enabled = FALSE;
+	}
+
+	if (mpt->m_txwq_thread_n) {
+		mutex_enter(&mpt->m_qthread_mutex);
+		for (j = 0; j < NUM_TX_WAITQ; j++) {
+			mutex_init(&mpt->m_tx_waitq[j].txwq_mutex, NULL,
+			    MUTEX_DRIVER,
+			    NULL);
+			cv_init(&mpt->m_tx_waitq[j].txwq_cv, NULL, CV_DRIVER,
+			    NULL);
+			cv_init(&mpt->m_tx_waitq[j].txwq_drain_cv, NULL,
+			    CV_DRIVER, NULL);
+			mpt->m_tx_waitq[j].txwq_active = TRUE;
+			mpt->m_tx_waitq[j].txwq_draining = FALSE;
+			mpt->m_tx_waitq[j].txwq_cmdq = NULL;
+			mpt->m_tx_waitq[j].txwq_qtail =
+			    &mpt->m_tx_waitq[j].txwq_cmdq;
+			mutex_enter(&mpt->m_tx_waitq[j].txwq_mutex);
+			mpt->m_tx_waitq[j].arg.mpt = mpt;
+			mpt->m_tx_waitq[j].arg.t = j;
+			mpt->m_tx_waitq[j].txwq_threadp =
+			    thread_create(NULL, 0, mptsas_tx_waitq_thread,
+			    &mpt->m_tx_waitq[j].arg,
+			    0, &p0, TS_RUN, maxclsyspri - 10);
+			mutex_exit(&mpt->m_tx_waitq[j].txwq_mutex);
+		}
+		mutex_exit(&mpt->m_qthread_mutex);
+		txwq_thread_create++;
+	}
+
 	mpt->m_doneq_thread_threshold = ddi_prop_get_int(DDI_DEV_T_ANY, dip,
 	    0, "mptsas_doneq_thread_threshold_prop", 10);
 	mpt->m_doneq_length_threshold = ddi_prop_get_int(DDI_DEV_T_ANY, dip,
 	    0, "mptsas_doneq_length_threshold_prop", 8);
 	mpt->m_doneq_thread_n = ddi_prop_get_int(DDI_DEV_T_ANY, dip,
-	    0, "mptsas_doneq_thread_n_prop", 8);
+	    0, "mptsas_doneq_thread_n_prop", min(NCPUS, 8));
 
 	if (mpt->m_doneq_thread_n) {
-		cv_init(&mpt->m_doneq_thread_cv, NULL, CV_DRIVER, NULL);
-		mutex_init(&mpt->m_doneq_mutex, NULL, MUTEX_DRIVER, NULL);
-
-		mutex_enter(&mpt->m_doneq_mutex);
+		mutex_enter(&mpt->m_qthread_mutex);
 		mpt->m_doneq_thread_id =
 		    kmem_zalloc(sizeof (mptsas_doneq_thread_list_t)
 		    * mpt->m_doneq_thread_n, KM_SLEEP);
@@ -1251,25 +1383,34 @@
 			mpt->m_doneq_thread_id[j].threadp =
 			    thread_create(NULL, 0, mptsas_doneq_thread,
 			    &mpt->m_doneq_thread_id[j].arg,
-			    0, &p0, TS_RUN, minclsyspri);
-			mpt->m_doneq_thread_id[j].donetail =
-			    &mpt->m_doneq_thread_id[j].doneq;
+			    0, &p0, TS_RUN, maxclsyspri - 10);
+			mpt->m_doneq_thread_id[j].dlist.dl_tail =
+			    &mpt->m_doneq_thread_id[j].dlist.dl_q;
 			mutex_exit(&mpt->m_doneq_thread_id[j].mutex);
 		}
-		mutex_exit(&mpt->m_doneq_mutex);
+		mutex_exit(&mpt->m_qthread_mutex);
 		doneq_thread_create++;
 	}
 
-	/* Initialize mutex used in interrupt handler */
-	mutex_init(&mpt->m_mutex, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(mpt->m_intr_pri));
+	/*
+	 * Disable hardware interrupt since we're not ready to
+	 * handle it yet.
+	 */
+	MPTSAS_DISABLE_INTR(mpt);
+
+	/*
+	 * Initialize mutex used in interrupt handler.
+	 * We don't support hi-level so the mutex's are all adaptive
+	 * and we don't want to register the interrupts until we get
+	 * the chip type information from _init_chip() below.
+	 * Otherwise we would use DDI_INTR_PRI(mpt->m_intr_pri)
+	 * rather than NULL in the mutex_init() calls.
+	 */
+	mutex_init(&mpt->m_mutex, NULL, MUTEX_DRIVER, NULL);
 	mutex_init(&mpt->m_passthru_mutex, NULL, MUTEX_DRIVER, NULL);
-	mutex_init(&mpt->m_tx_waitq_mutex, NULL, MUTEX_DRIVER,
-	    DDI_INTR_PRI(mpt->m_intr_pri));
 	for (i = 0; i < MPTSAS_MAX_PHYS; i++) {
 		mutex_init(&mpt->m_phy_info[i].smhba_info.phy_mutex,
-		    NULL, MUTEX_DRIVER,
-		    DDI_INTR_PRI(mpt->m_intr_pri));
+		    NULL, MUTEX_DRIVER, NULL);
 	}
 
 	cv_init(&mpt->m_cv, NULL, CV_DRIVER, NULL);
@@ -1279,15 +1420,6 @@
 	cv_init(&mpt->m_fw_diag_cv, NULL, CV_DRIVER, NULL);
 	mutex_init_done++;
 
-	/*
-	 * Disable hardware interrupt since we're not ready to
-	 * handle it yet.
-	 */
-	MPTSAS_DISABLE_INTR(mpt);
-	if (mptsas_register_intrs(mpt) == FALSE)
-		goto fail;
-	intr_added++;
-
 	mutex_enter(&mpt->m_mutex);
 	/*
 	 * Initialize power management component
@@ -1332,6 +1464,19 @@
 		goto fail;
 	}
 
+	/*
+	 * If we only have one interrupt the default for doneq_thread_threshold
+	 * should be 0 so that all completion processing goes to the threads.
+	 * Only change it if it wasn't set from .conf file.
+	 */
+	if (mpt->m_doneq_thread_n != 0 &&
+	    ddi_prop_exists(DDI_DEV_T_ANY, dip,
+	    0, "mptsas_doneq_length_threshold_prop") == 0 &&
+	    mpt->m_intr_cnt == 1) {
+		mpt->m_doneq_length_threshold = 0;
+	}
+
+
 	mutex_exit(&mpt->m_mutex);
 
 	/*
@@ -1365,10 +1510,8 @@
 	/*
 	 * Initialize the wait and done FIFO queue
 	 */
-	mpt->m_donetail = &mpt->m_doneq;
+	mpt->m_dlist.dl_tail = &mpt->m_dlist.dl_q;
 	mpt->m_waitqtail = &mpt->m_waitq;
-	mpt->m_tx_waitqtail = &mpt->m_tx_waitq;
-	mpt->m_tx_draining = 0;
 
 	/*
 	 * ioc cmd queue initialize
@@ -1389,7 +1532,28 @@
 	mutex_exit(&mpt->m_mutex);
 
 	/*
-	 * Initialize PHY info for smhba
+	 * used for mptsas_watch
+	 */
+	mptsas_list_add(mpt);
+
+	mutex_enter(&mptsas_global_mutex);
+	if (mptsas_timeouts_enabled == 0) {
+		mptsas_scsi_watchdog_tick = ddi_prop_get_int(DDI_DEV_T_ANY,
+		    dip, 0, "scsi-watchdog-tick", DEFAULT_WD_TICK);
+
+		mptsas_tick = mptsas_scsi_watchdog_tick *
+		    drv_usectohz((clock_t)1000000);
+
+		mptsas_timeout_id = timeout(mptsas_watch, NULL, mptsas_tick);
+		mptsas_timeouts_enabled = 1;
+	}
+	mutex_exit(&mptsas_global_mutex);
+	added_watchdog++;
+
+	/*
+	 * Initialize PHY info for smhba.
+	 * This requires watchdog to be enabled otherwise if interrupts
+	 * don't work the system will hang.
 	 */
 	if (mptsas_smhba_setup(mpt)) {
 		mptsas_log(mpt, CE_WARN, "mptsas phy initialization "
@@ -1400,6 +1564,8 @@
 	/* Check all dma handles allocated in attach */
 	if ((mptsas_check_dma_handle(mpt->m_dma_req_frame_hdl)
 	    != DDI_SUCCESS) ||
+	    (mptsas_check_dma_handle(mpt->m_dma_req_sense_hdl)
+	    != DDI_SUCCESS) ||
 	    (mptsas_check_dma_handle(mpt->m_dma_reply_frame_hdl)
 	    != DDI_SUCCESS) ||
 	    (mptsas_check_dma_handle(mpt->m_dma_free_queue_hdl)
@@ -1415,6 +1581,8 @@
 	if ((mptsas_check_acc_handle(mpt->m_datap) != DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_req_frame_hdl)
 	    != DDI_SUCCESS) ||
+	    (mptsas_check_acc_handle(mpt->m_acc_req_sense_hdl)
+	    != DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_reply_frame_hdl)
 	    != DDI_SUCCESS) ||
 	    (mptsas_check_acc_handle(mpt->m_acc_free_queue_hdl)
@@ -1431,23 +1599,6 @@
 	/*
 	 * After this point, we are not going to fail the attach.
 	 */
-	/*
-	 * used for mptsas_watch
-	 */
-	mptsas_list_add(mpt);
-
-	mutex_enter(&mptsas_global_mutex);
-	if (mptsas_timeouts_enabled == 0) {
-		mptsas_scsi_watchdog_tick = ddi_prop_get_int(DDI_DEV_T_ANY,
-		    dip, 0, "scsi-watchdog-tick", DEFAULT_WD_TICK);
-
-		mptsas_tick = mptsas_scsi_watchdog_tick *
-		    drv_usectohz((clock_t)1000000);
-
-		mptsas_timeout_id = timeout(mptsas_watch, NULL, mptsas_tick);
-		mptsas_timeouts_enabled = 1;
-	}
-	mutex_exit(&mptsas_global_mutex);
 
 	/* Print message of HBA present */
 	ddi_report_dev(dip);
@@ -1464,18 +1615,22 @@
 	mptsas_fm_ereport(mpt, DDI_FM_DEVICE_NO_RESPONSE);
 	ddi_fm_service_impact(mpt->m_dip, DDI_SERVICE_LOST);
 	if (mpt) {
-		mutex_enter(&mptsas_global_mutex);
+		/* deallocate in reverse order */
+		if (added_watchdog) {
+			mptsas_list_del(mpt);
+			mutex_enter(&mptsas_global_mutex);
 
-		if (mptsas_timeout_id && (mptsas_head == NULL)) {
-			timeout_id_t tid = mptsas_timeout_id;
-			mptsas_timeouts_enabled = 0;
-			mptsas_timeout_id = 0;
+			if (mptsas_timeout_id && (mptsas_head == NULL)) {
+				timeout_id_t tid = mptsas_timeout_id;
+				mptsas_timeouts_enabled = 0;
+				mptsas_timeout_id = 0;
+				mutex_exit(&mptsas_global_mutex);
+				(void) untimeout(tid);
+				mutex_enter(&mptsas_global_mutex);
+			}
 			mutex_exit(&mptsas_global_mutex);
-			(void) untimeout(tid);
-			mutex_enter(&mptsas_global_mutex);
 		}
-		mutex_exit(&mptsas_global_mutex);
-		/* deallocate in reverse order */
+
 		mptsas_cache_destroy(mpt);
 
 		if (smp_attach_setup) {
@@ -1493,14 +1648,14 @@
 		if (mpt->m_active) {
 			mptsas_free_active_slots(mpt);
 		}
-		if (intr_added) {
+		if (mpt->m_intr_cnt) {
 			mptsas_unregister_intrs(mpt);
 		}
 
 		if (doneq_thread_create) {
-			mutex_enter(&mpt->m_doneq_mutex);
-			doneq_thread_num = mpt->m_doneq_thread_n;
-			for (j = 0; j < mpt->m_doneq_thread_n; j++) {
+			mutex_enter(&mpt->m_qthread_mutex);
+			q_thread_num = mpt->m_doneq_thread_n;
+			for (j = 0; j < q_thread_num; j++) {
 				mutex_enter(&mpt->m_doneq_thread_id[j].mutex);
 				mpt->m_doneq_thread_id[j].flag &=
 				    (~MPTSAS_DONEQ_THREAD_ACTIVE);
@@ -1508,19 +1663,36 @@
 				mutex_exit(&mpt->m_doneq_thread_id[j].mutex);
 			}
 			while (mpt->m_doneq_thread_n) {
-				cv_wait(&mpt->m_doneq_thread_cv,
-				    &mpt->m_doneq_mutex);
+				cv_wait(&mpt->m_qthread_cv,
+				    &mpt->m_qthread_mutex);
 			}
-			for (j = 0; j < doneq_thread_num; j++) {
+			for (j = 0; j < q_thread_num; j++) {
 				cv_destroy(&mpt->m_doneq_thread_id[j].cv);
 				mutex_destroy(&mpt->m_doneq_thread_id[j].mutex);
 			}
 			kmem_free(mpt->m_doneq_thread_id,
 			    sizeof (mptsas_doneq_thread_list_t)
-			    * doneq_thread_num);
-			mutex_exit(&mpt->m_doneq_mutex);
-			cv_destroy(&mpt->m_doneq_thread_cv);
-			mutex_destroy(&mpt->m_doneq_mutex);
+			    * q_thread_num);
+			mutex_exit(&mpt->m_qthread_mutex);
+		}
+		if (txwq_thread_create) {
+			mutex_enter(&mpt->m_qthread_mutex);
+			q_thread_num = mpt->m_txwq_thread_n;
+			for (j = 0; j < q_thread_num; j++) {
+				mutex_enter(&mpt->m_tx_waitq[j].txwq_mutex);
+				mpt->m_tx_waitq[j].txwq_active = FALSE;
+				cv_signal(&mpt->m_tx_waitq[j].txwq_cv);
+				mutex_exit(&mpt->m_tx_waitq[j].txwq_mutex);
+			}
+			while (mpt->m_txwq_thread_n) {
+				cv_wait(&mpt->m_qthread_cv,
+				    &mpt->m_qthread_mutex);
+			}
+			for (j = 0; j < q_thread_num; j++) {
+				cv_destroy(&mpt->m_tx_waitq[j].txwq_cv);
+				cv_destroy(&mpt->m_tx_waitq[j].txwq_drain_cv);
+				mutex_destroy(&mpt->m_tx_waitq[j].txwq_mutex);
+			}
 		}
 		if (event_taskq_create) {
 			ddi_taskq_destroy(mpt->m_event_taskq);
@@ -1529,13 +1701,14 @@
 			ddi_taskq_destroy(mpt->m_dr_taskq);
 		}
 		if (mutex_init_done) {
-			mutex_destroy(&mpt->m_tx_waitq_mutex);
+			mutex_destroy(&mpt->m_qthread_mutex);
 			mutex_destroy(&mpt->m_passthru_mutex);
 			mutex_destroy(&mpt->m_mutex);
 			for (i = 0; i < MPTSAS_MAX_PHYS; i++) {
 				mutex_destroy(
 				    &mpt->m_phy_info[i].smhba_info.phy_mutex);
 			}
+			cv_destroy(&mpt->m_qthread_cv);
 			cv_destroy(&mpt->m_cv);
 			cv_destroy(&mpt->m_passthru_cv);
 			cv_destroy(&mpt->m_fw_cv);
@@ -1553,7 +1726,7 @@
 		mptsas_hba_fini(mpt);
 
 		mptsas_fm_fini(mpt);
-		ddi_soft_state_free(mptsas_state, instance);
+		ddi_soft_state_free(mptsas3_state, instance);
 		ddi_prop_remove_all(dip);
 	}
 	return (DDI_FAILURE);
@@ -1767,7 +1940,7 @@
 	int		circ1 = 0;
 	mdi_pathinfo_t	*pip = NULL;
 	int		i;
-	int		doneq_thread_num = 0;
+	int		q_thread_num = 0;
 
 	NDBG0(("mptsas_do_detach: dip=0x%p", (void *)dip));
 
@@ -1815,7 +1988,7 @@
 			if (pm_raise_power(dip, 0, PM_LEVEL_D0) !=
 			    DDI_SUCCESS) {
 				mptsas_log(mpt, CE_WARN,
-				    "mptsas%d: Raise power request failed.",
+				    "mptsas3%d: Raise power request failed.",
 				    mpt->m_instance);
 				(void) pm_idle_component(dip, 0);
 				return (DDI_FAILURE);
@@ -1839,8 +2012,8 @@
 	ddi_taskq_destroy(mpt->m_dr_taskq);
 
 	if (mpt->m_doneq_thread_n) {
-		mutex_enter(&mpt->m_doneq_mutex);
-		doneq_thread_num = mpt->m_doneq_thread_n;
+		mutex_enter(&mpt->m_qthread_mutex);
+		q_thread_num = mpt->m_doneq_thread_n;
 		for (i = 0; i < mpt->m_doneq_thread_n; i++) {
 			mutex_enter(&mpt->m_doneq_thread_id[i].mutex);
 			mpt->m_doneq_thread_id[i].flag &=
@@ -1849,19 +2022,36 @@
 			mutex_exit(&mpt->m_doneq_thread_id[i].mutex);
 		}
 		while (mpt->m_doneq_thread_n) {
-			cv_wait(&mpt->m_doneq_thread_cv,
-			    &mpt->m_doneq_mutex);
+			cv_wait(&mpt->m_qthread_cv,
+			    &mpt->m_qthread_mutex);
 		}
-		for (i = 0;  i < doneq_thread_num; i++) {
+		for (i = 0;  i < q_thread_num; i++) {
 			cv_destroy(&mpt->m_doneq_thread_id[i].cv);
 			mutex_destroy(&mpt->m_doneq_thread_id[i].mutex);
 		}
 		kmem_free(mpt->m_doneq_thread_id,
 		    sizeof (mptsas_doneq_thread_list_t)
-		    * doneq_thread_num);
-		mutex_exit(&mpt->m_doneq_mutex);
-		cv_destroy(&mpt->m_doneq_thread_cv);
-		mutex_destroy(&mpt->m_doneq_mutex);
+		    * q_thread_num);
+		mutex_exit(&mpt->m_qthread_mutex);
+	}
+	if (mpt->m_txwq_thread_n) {
+		mutex_enter(&mpt->m_qthread_mutex);
+		q_thread_num = mpt->m_txwq_thread_n;
+		for (i = 0; i < q_thread_num; i++) {
+			mutex_enter(&mpt->m_tx_waitq[i].txwq_mutex);
+			mpt->m_tx_waitq[i].txwq_active = FALSE;
+			cv_signal(&mpt->m_tx_waitq[i].txwq_cv);
+			mutex_exit(&mpt->m_tx_waitq[i].txwq_mutex);
+		}
+		while (mpt->m_txwq_thread_n) {
+			cv_wait(&mpt->m_qthread_cv,
+			    &mpt->m_qthread_mutex);
+		}
+		for (i = 0; i < q_thread_num; i++) {
+			cv_destroy(&mpt->m_tx_waitq[i].txwq_cv);
+			cv_destroy(&mpt->m_tx_waitq[i].txwq_drain_cv);
+			mutex_destroy(&mpt->m_tx_waitq[i].txwq_mutex);
+		}
 	}
 
 	scsi_hba_reset_notify_tear_down(mpt->m_reset_notify_listf);
@@ -1942,17 +2132,18 @@
 	if (mpt->m_options & MPTSAS_OPT_PM) {
 		if (pm_lower_power(dip, 0, PM_LEVEL_D3) != DDI_SUCCESS)
 			mptsas_log(mpt, CE_WARN,
-			    "!mptsas%d: Lower power request failed "
+			    "!mptsas3%d: Lower power request failed "
 			    "during detach, ignoring.",
 			    mpt->m_instance);
 	}
 
-	mutex_destroy(&mpt->m_tx_waitq_mutex);
+	mutex_destroy(&mpt->m_qthread_mutex);
 	mutex_destroy(&mpt->m_passthru_mutex);
 	mutex_destroy(&mpt->m_mutex);
 	for (i = 0; i < MPTSAS_MAX_PHYS; i++) {
 		mutex_destroy(&mpt->m_phy_info[i].smhba_info.phy_mutex);
 	}
+	cv_destroy(&mpt->m_qthread_cv);
 	cv_destroy(&mpt->m_cv);
 	cv_destroy(&mpt->m_passthru_cv);
 	cv_destroy(&mpt->m_fw_cv);
@@ -1968,7 +2159,7 @@
 	mptsas_free_handshake_msg(mpt);
 
 	mptsas_fm_fini(mpt);
-	ddi_soft_state_free(mptsas_state, ddi_get_instance(dip));
+	ddi_soft_state_free(mptsas3_state, ddi_get_instance(dip));
 	ddi_prop_remove_all(dip);
 
 	return (DDI_SUCCESS);
@@ -2021,6 +2212,7 @@
 {
 	ddi_dma_attr_t	task_dma_attrs;
 
+	mpt->m_hshk_dma_size = 0;
 	task_dma_attrs = mpt->m_msg_dma_attr;
 	task_dma_attrs.dma_attr_sgllen = 1;
 	task_dma_attrs.dma_attr_granular = (uint32_t)(alloc_size);
@@ -2039,6 +2231,8 @@
 static void
 mptsas_free_handshake_msg(mptsas_t *mpt)
 {
+	if (mpt->m_hshk_dma_size == 0)
+		return;
 	mptsas_dma_addr_destroy(&mpt->m_hshk_dma_hdl, &mpt->m_hshk_acc_hdl);
 	mpt->m_hshk_dma_size = 0;
 }
@@ -2216,9 +2410,9 @@
 	/*
 	 * create kmem cache for packets
 	 */
-	(void) sprintf(buf, "mptsas%d_cache", instance);
+	(void) sprintf(buf, "mptsas3%d_cache", instance);
 	mpt->m_kmem_cache = kmem_cache_create(buf,
-	    sizeof (struct mptsas_cmd) + scsi_pkt_size(), 8,
+	    sizeof (struct mptsas_cmd) + scsi_pkt_size(), 16,
 	    mptsas_kmem_cache_constructor, mptsas_kmem_cache_destructor,
 	    NULL, (void *)mpt, NULL, 0);
 
@@ -2231,9 +2425,9 @@
 	 * create kmem cache for extra SGL frames if SGL cannot
 	 * be accomodated into main request frame.
 	 */
-	(void) sprintf(buf, "mptsas%d_cache_frames", instance);
+	(void) sprintf(buf, "mptsas3%d_cache_frames", instance);
 	mpt->m_cache_frames = kmem_cache_create(buf,
-	    sizeof (mptsas_cache_frames_t), 8,
+	    sizeof (mptsas_cache_frames_t), 16,
 	    mptsas_cache_frames_constructor, mptsas_cache_frames_destructor,
 	    NULL, (void *)mpt, NULL, 0);
 
@@ -2273,7 +2467,7 @@
 	if (scsi_hba_iport_unit_address(dip) != 0)
 		return (DDI_SUCCESS);
 
-	mpt = ddi_get_soft_state(mptsas_state, ddi_get_instance(dip));
+	mpt = ddi_get_soft_state(mptsas3_state, ddi_get_instance(dip));
 	if (mpt == NULL) {
 		return (DDI_FAILURE);
 	}
@@ -2289,7 +2483,7 @@
 	}
 	switch (level) {
 	case PM_LEVEL_D0:
-		NDBG11(("mptsas%d: turning power ON.", mpt->m_instance));
+		NDBG11(("mptsas3%d: turning power ON.", mpt->m_instance));
 		MPTSAS_POWER_ON(mpt);
 		/*
 		 * Wait up to 30 seconds for IOC to come out of reset.
@@ -2318,11 +2512,11 @@
 		mpt->m_power_level = PM_LEVEL_D0;
 		break;
 	case PM_LEVEL_D3:
-		NDBG11(("mptsas%d: turning power OFF.", mpt->m_instance));
+		NDBG11(("mptsas3%d: turning power OFF.", mpt->m_instance));
 		MPTSAS_POWER_OFF(mpt);
 		break;
 	default:
-		mptsas_log(mpt, CE_WARN, "mptsas%d: unknown power level <%x>.",
+		mptsas_log(mpt, CE_WARN, "mptsas3%d: unknown power level <%x>.",
 		    mpt->m_instance, level);
 		rval = DDI_FAILURE;
 		break;
